from netspresso.trainer.augmentations.augmentation import (
    AugmentationConfig,
    CenterCrop,
    ClassificationAugmentationConfig,
    ColorJitter,
    DetectionAugmentationConfig,
    HSVJitter,
    Mixing,
    MosaicDetection,
    Pad,
    PoseTopDownAffine,
    RandomCrop,
    RandomCutmix,
    RandomErasing,
    RandomHorizontalFlip,
    RandomMixup,
    RandomResize,
    RandomResizedCrop,
    RandomVerticalFlip,
    Resize,
    SegmentationAugmentationConfig,
    Transform,
    TrivialAugmentWide,
)

AUGMENTATION_CONFIG_TYPE = {
    "classification": ClassificationAugmentationConfig,
    "detection": DetectionAugmentationConfig,
    "segmentation": SegmentationAugmentationConfig,
}


__all__ = [
    "CenterCrop",
    "HSVJitter",
    "Mixing",
    "MosaicDetection",
    "PoseTopDownAffine",
    "RandomErasing",
    "RandomResize",
    "ColorJitter",
    "Pad",
    "RandomCrop",
    "RandomResizedCrop",
    "RandomHorizontalFlip",
    "RandomVerticalFlip",
    "Resize",
    "TrivialAugmentWide",
    "RandomMixup",
    "RandomCutmix",
    "Transform",
    "AugmentationConfig",
    "AUGMENTATION_CONFIG_TYPE",
]
